#include "stokes.h"

#include <dataformathandler.h>
#include <filescanner.h>



void Stokes::point(double h, const FemFunction &U, const Vertex2d &v) const
{
  //TODO 4.1 (c) set alpha
}


void Stokes::Form(VectorIterator b,
                      const FemFunction &U,
                      const TestFunction &N) const
{
  //TODO 4.1 (b), (c) add a stabilization term

  b[0] += (U[1].x()+U[2].y() )*N.m();
 
  b[1] += data.visc * (U[1].x() * N.x() + U[1].y() * N.y());
  b[1] -= U[0].m()*N.x();

  b[2] += data.visc * (U[2].x() * N.x() + U[2].y() * N.y());
  b[2] -= U[0].m()*N.y();
  
}


void Stokes::Matrix(EntryMatrix &A,
                        const FemFunction &U,
                        const TestFunction &M,
                        const TestFunction &N) const
{
  //TODO 4.1 (b), (c) add a stabilization term

  //b[0] += (U[1].x()+U[2].y())*N.m();
  A(0,1) += M.x()*N.m();
  A(0,2) += M.y()*N.m();

 //b[1] += _visc * (U[1].x() * N.x() + U[1].y() * N.y());
  A(1,1) += data.visc*(M.x()*N.x() + M.y()*N.y());

  //b[1] -= U[0].m()*N.x();
  A(1,0) -= M.m()*N.x();

  //b[2] += _visc * (U[2].x() * N.x() + U[2].y() * N.y());
  A(2,2) += data.visc * (M.x()*N.x() + M.y()*N.y());

  //b[2] -= U[0].m()*N.y();
  A(2,0) -= M.m()*N.y();
  
}